
# possible actions...
IGNORE = 0
MUSTAUTH = 1
AUTHAS = 2
AUTHASIFANON = 3

# and their descriptions...
actions_desc = ((IGNORE, 'May be anonymous'),
                (MUSTAUTH, 'Must be authenticated'),
                (AUTHAS, 'Unconditionally authenticate as'),
                (AUTHASIFANON, 'If anonymous, authenticate as'),
                )

class Action:
    """Action object for use from DTML.
    """
    
    def __init__(self, action):
        """Initialize object

        action is a tuple (id_a, title_a)
        """
        self.id_a, self.title_a = action

def check_action(id_a, error_msg='Invalid action id'):
    """Raise an error if id_a is not a valid action id
    """
    try: id_a = int(id_a)
    except: raise ValueError, error_msg
    if id_a < IGNORE or id_a > AUTHASIFANON:
        raise ValueError, error_msg
    return id_a

def get_actions():
    """return a list of defined actions, and a id_a/action object mapping
    """
    actions_list = map(Action, actions_desc)
    
    actions_dict = {}
    for action in actions_list:
        actions_dict[action.id_a] = action
    return actions_list, actions_dict
