from string import split, strip
from App.version_txt import version_txt
from zLOG import WARNING, LOG

# Zope version
version = split(version_txt())[1]
version = tuple(map(int, map(strip, split(version, '.'))[:2]))
major, minor = version

IS_ACTIVE = 0

def install(context):
    global IS_ACTIVE

    if version == (2, 1):
        # Zope 2.1.x
        import Patch
        if Patch.install():
            IS_ACTIVE = 1
            
    elif major == 2 and minor >= 2:
        # Zope >= 2.2.x
        import Hook
        if Hook.install(context._ProductContext__app):
            IS_ACTIVE = 1

    else:
        LOG('jcForceAuth', WARNING, 'No compatible Zope release found. Cannot install jcForceAuth')

def uninstall(context):
    global IS_ACTIVE

    if version == (2, 1):
        # Zope 2.1.x
        import Patch
        if Patch.uninstall():
            IS_ACTIVE = 0
            
    elif major == 2 and minor >= 2:
        # Zope >= 2.2.x
        import Hook
        if Hook.uninstall(context._ProductContext__app):
            IS_ACTIVE = 0

    else:
        LOG('jcForceAuth', WARNING, 'No compatible Zope release found. Cannot uninstall jcForceAuth')
