
from time import time
from base64 import encodestring
from Globals import HTMLFile
from ForceAuth import IS_ACTIVE
from Actions import IGNORE, MUSTAUTH, AUTHAS, AUTHASIFANON
from Actions import check_action, get_actions
from Rules import load_rules, save_rules, apply_rules

_editRulesForm = HTMLFile('www/editRulesForm', globals(), __name__='manage_editRulesForm')
def manage_editRulesForm(self, REQUEST=None, **kw):
    """manage rules"""
    
    kw.update({'IS_ACTIVE': IS_ACTIVE,
               'IGNORE': IGNORE,
               'MUSTAUTH': MUSTAUTH,
               'AUTHAS': AUTHAS,
               'AUTHASIFANON': AUTHASIFANON,
               })
    kw['rules'] = load_rules(1)
    kw['actions_list'], kw['actions'] = get_actions()

    return apply(_editRulesForm, (self, self, REQUEST), kw)

def manage_editRules(self, method, ids_r=(), REQUEST=None, **kw):
    """Edit one or more rules
    """
    if method == 'First':
        ids_r = map(int, ids_r)
        rules = []
        i = 0
        for rule in load_rules():
            if rule[0] in ids_r:
                rules.insert(i, rule)
                i = i + 1
            else:
                rules.append(rule)
        save_rules(rules)

    elif method == 'Delete':
        ids_r = map(int, ids_r)
        rules = []
        for rule in load_rules():
            if rule[0] in ids_r:
                continue
            rules.append(rule)
        save_rules(rules)

    else:
        raise ValueError, "invalid method"

    if REQUEST is not None:
        return self.manage_editRulesForm(REQUEST)
    
def manage_addRule(self, domains_r, id_a,
                   name_r='', password='', confirm='',
                   excepts_r=(),
                   REQUEST=None, **kw):
    """Add a new rule
    """
    id_r = int(time())
    domains_r = tuple(domains_r)
    if not domains_r:
        domains_r = ('*', )
    id_a = check_action(id_a)
    if id_a in (IGNORE, MUSTAUTH):
        name_r = auth_r = ''
    elif id_a in (AUTHAS, AUTHASIFANON):
        if not name_r:
            raise ValueError, "User name must be specified"
        if password != confirm:
            raise ValueError, "Password and confirm do not match"
        auth_r = 'basic ' + encodestring(name_r + ':' + password)
    excepts_r = tuple(excepts_r)

    # update the ZODB
    rule = (id_r, domains_r, id_a, name_r, auth_r, excepts_r)
    save_rules(load_rules() + (rule, ))
    
    if REQUEST is not None:
        return self.manage_editRulesForm(REQUEST)

def manage_applyRules(self, REQUEST=None, **kw):
    """Apply changes and 'quit' the configuration page
    """
    apply_rules()
    
    if REQUEST is not None:
        # manage_main is a factory dispatcher method that will redirect for us
        return self.manage_main(self, REQUEST)

def initialize(context):
    context.registerClass(meta_type='Configure jcForceAuth',
                          permission='Configure jcForceAuth',
                          constructors=(manage_editRulesForm,
                                        manage_editRules,
                                        manage_addRule,
                                        manage_applyRules,
                                        ),
                          )
